<?php
 /*
Template Name: 联系
*/ 
if( isset($_POST['message_form']) && $_POST['message_form'] == 'send') {
    global $wpdb;
    $current_url = get_site_url()/contact; 

    $last_post = $wpdb->get_var("SELECT `post_date` FROM `$wpdb->posts` ORDER BY `post_date` DESC LIMIT 1");

    if ( (current_time('timestamp') - strtotime($last_post)) < 10 ) {
        wp_die('您刚刚已经给我们发送过留言，请稍后重试！<a href="'.$current_url.'">点此返回</a>');
    }
        
    $name = isset( $_POST['message_authorname'] ) ? trim(htmlspecialchars($_POST['message_authorname'], ENT_QUOTES)) : '';
    $title =  isset( $_POST['message_title'] ) ? trim(htmlspecialchars($_POST['message_title'], ENT_QUOTES)) : '';
    $content =  isset( $_POST['message_content'] ) ? trim(htmlspecialchars($_POST['message_content'], ENT_QUOTES)) : '';
    $tel = isset( $_POST['message_authortel'] ) ? trim(htmlspecialchars($_POST['message_authortel'], ENT_QUOTES)) : '';
    
    // 表单项数据验证
    if ( empty($name) || mb_strlen($name) > 20 ) {
        wp_die('昵称必须填写，且长度不得超过20字。<a href="'.$current_url.'">点此返回</a>');
    }

    if ( empty($tel) || strlen($tel) < 7 || !preg_match("/^[0-9]+$/", $tel)) {
        wp_die('手机/电话必须填写，且长度不少于7个字符。<a href="'.$current_url.'">点此返回</a>');
    }
    
    if ( empty($title) || mb_strlen($title) > 100 ) {
        wp_die('需求标题必须填写，且长度不得超过100字。<a href="'.$current_url.'">点此返回</a>');
    }

    $post_content = $content;
    
    $message = array(
	'post_type' => 'message',
        'post_title' => $title, 
        'post_content' => $post_content,
	'tax_input' => array( 'message-types' => array(43)),
	'post_status' =>'private',
	'post_author'  =>1,
    );


    // 将文章插入数据库
    $status = wp_insert_post( $message );
  
    if ($status != 0) { 
	add_post_meta($status, 'message_authorname', $name, TRUE); 
	add_post_meta($status, 'message_authortel', $tel, TRUE); 
    }
}
get_header();?>
	<div class="page_bar"></div>
<div id="wrapper" class="container_12 clearfix white-wp">
	<!-- Caption Line -->
	<br /><br />
	<h2 class="grid_6 caption clearfix">联系我们</h2>
	<div class="hr grid_12 clearfix">&nbsp;</div>
	<?php if (empty($_POST['message_authortel'])){} else { echo '<p class="grid_12 clearfix success-tips">感谢您的留言咨询，我们将在24小时内回复您！</p>';}?>

<?php if(strpos($_SERVER["HTTP_USER_AGENT"],"MSIE 7.0")){echo "<!--";}else if(strpos($_SERVER["HTTP_USER_AGENT"],"MSIE 6.0")){echo "<!--";}else {echo "";}?>
	<div class="grid_12" style="height:300px;margin-bottom:30px;">
		<?php include(TEMPLATEPATH.'/includes/amap-mark.php');?>
	</div>
		<div class="hr dotted clearfix">&nbsp;</div>
<?php if(strpos($_SERVER["HTTP_USER_AGENT"],"MSIE 7.0")){echo " -->";}else if(strpos($_SERVER["HTTP_USER_AGENT"],"MSIE 6.0")){echo " -->";}else {echo "";}?>

	<div class="grid_12">
		<div class="grid_4" style="margin-left:0px;">
		<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
			<div class="content">
				<?php the_content();?>
			</div>
		<?php endwhile; endif; ?>
		</div>
		<div class="grid_8" style="margin:0;">
			<h4>拨打电话&nbsp;<span style="color: #F40028;text-decoration:underline;">18062118578</span>&nbsp;或者填写下方表单，让我们联系您！</h4>
			<div class="hr dotted clearfix">&nbsp;</div>
			<form class="bno-message" method="post" action="<?php echo $_SERVER["REQUEST_URI"]; $current_user = wp_get_current_user(); ?>" id="contact_form">
			<ul>
				<li class="clearfix">
					<label for="message_authorname">您的称呼(必填)</label>
					<input type='text' value="" name="message_authorname" id="message_authorname" />
					<div class="clear"></div>
				</li>
				<li class="clearfix">
					<label for="message_authortel">联系电话(必填)</label>
					<input type='text' value="" name='message_authortel' id='message_authortel' />
					<div class="clear"></div>
				</li>
				<li class="clearfix">
					<label for="message_title">需求标题(必填)</label>
					<input type='text' value="" name="message_title" id="message_title" />
					<div class="clear"></div>
				</li>
				<li class="clearfix">
					<label for="message_content">需求描述</label>
					<textarea name="message_content" id="message_content" rows="10" cols="30"></textarea>
					<div class="clear"></div>
				</li>
				<li class="clearfix">
					<div id="button">
					        <input type="hidden" value="send" name="message_form" />
						<input type='submit' class="msgbtn" value='发送' />
					</div>
				</li>
			</ul>
		</form>
	    </div>	
	</div>
	<div class="hr grid_12 clearfix">&nbsp;</div>
<?php get_footer();?>