<?php
 
function post_frontend_form_register() {	

function cmb_only_show_for_user_1( $field ) {
	return 1 === get_current_user_id();
}

//for post
	$cmb_post = new_cmb2_box( array(
		'id'           => 'front-end-post-form',
		'object_types' => array( 'post' ),
		'hookup'       => false,
		'cmb_styles' => false,		
		'save_fields'  => false,
	) );
	
	$cmb_post->add_field( array( // 标题模块
		'name'    => __( '标题', 'chumi' ),
		'id'      => 'submitted_post_title',
		'type'    => 'text',		
		'show_names' => false,
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>"在此输入标题",
		),
	) ); 

	$cmb_post->add_field( array( // 内容模块
		'name'    => __( '内容', 'chumi' ),
		'id'      => 'submitted_post_content',
		'show_names' => false,
		'type'    => 'wysiwyg', 
		'attributes' => array(
			'class'=>'required',
		),		
		'options' => array(
			'media_buttons' => true, 
			//'teeny' => true,
			'tinymce' => true, 
			'class'=>'required',
			'textarea_rows' => 25, 
			'quicktags' => false 
		),
	) );		
	$cmb_post->add_field( array( //分类模块
		'name'    =>  __( '选择分类', 'cmb2' ),
		'id'      => 'submitted_post_cat',
		'type'    => 'terms_rdo_inline', //该函数定义在最前面
	) );
	
	$cmb_post->add_field( array(
		'name'    =>  __( '设置封面图片', 'cmb2' ),
		'id'      => 'post_thumbnail',
		'type'    => 'file',
		'query_args' => array(
			'type' => array('image/jpeg','image/gif','image/png','image/bmp'),
		),	
		'options' => array(
			'url' => false, // Hide the text input for the url
		),
	) );	
	
	$cmb_post->add_field( array( //标签
		'name'    =>  __( '添加关键词' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
			'autocomplete' => 'off',
		),			
	) ); 
 	$cmb_post->add_field( array( //站外链接
		'name' => __( '选择或注明文章版权信息', 'cmb2' ),
		'id'   => 'copyright',
		'type' => 'copyright',//定义在文档开头
	) ); 

 	$cmb_post->add_field( array( 
		'id'      => 'zhuanzai',
		'type'    => 'text',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>"输入来源名称……",
			'showon'=>"w",
		),		
	) );
	$cmb_post->add_field( array( 
		'id'      => 'wangzhi',
		'type'    => 'text_link',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>"网址前请加上http://",
			'showon'=>"w",
			
		),	
	) );
	
	$cmb_post->add_field( array( 
		'id'      => 'qikan',
		'type'    => 'text_medium',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>"输入期刊名称、期数等……",
			'showon'=>"k",//js控制			
		),	
	) );
	
	$cmb_post->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'post_script', 
	) ); 


// for video

	$cmb = new_cmb2_box( array(
		'id'           => 'front-end-video-form',
		'object_types' => array( 'video' ),
		'hookup'       => false,
		'cmb_styles' => false,
		'save_fields'  => false,
	) );	

		$cmb->add_field( array(
			'name'    => __( '选择上传或转载视频', 'cmb2' ),
			'id'      => 'video_sharemode',
			'type'    => 'video_sharemode',
		) );

		$cmb->add_field( array(
			'name'    =>  __( '上传或选择视频', 'cmb2' ),
			'show_names' => false,
			'id'      => 'video',
			'type'    => 'file',
			'query_args' => array(
				'type' => 'video/mp4 ', 
			),
			'before_field' =>input_after_check_set('add_gifplayer','启用Gif播放器(启用后将不播放视频中的声音)'),
			'attributes'  => array(		
				'autocomplete' => 'off',
				'showon'=>'video_upload',
			),				
		) );

		$cmb->add_field( array(
			'id'   => 'add_gifplayer',
			'type' => 'hidden',			
		) );
		
		$cmb->add_field( array(
			'id'      => 'fake_video',
			'type'    => 'text_link',
			'show_on_cb' => 'cmb_only_show_for_user_1',
			'attributes'  => array(
				'showon'=>'video_upload',
				'autocomplete' => 'off', 
			),				
		) );		
		
		$cmb->add_field( array(
			'id'      => 'videouri',
			'type'    => 'text_link',
			'attributes'  => array(		
				'autocomplete' => 'off',
				'class'=>'required',
				'showon'=>"video_reprint",
				'placeholder'=>"网址前请加上http://",				
			),				
		) );

		$cmb->add_field( array(
			'id'      => 'wechat_videouri',
			'type'    => 'text_link',
			'attributes'  => array(		
				'autocomplete' => 'off',
				'class'=>'required',
				'showon'=>"wechat_video_reprint",
				'placeholder'=>"网址前请加上http://",				
			),				
		) );		

		// and prepend title
		$cmb->add_field( array(
			'name'   => __( '视频标题', 'cmb2' ),
			'id'     => 'submitted_post_title',
			'type'    => 'text',
			'attributes' => array(
				'autocomplete' => 'off', 
				'class'=>'required',
				'placeholder'=>"在此输入视频标题……",
			),			
			//'before' => 'jt_edit_core_maybe_redirect',
		) );

		// and content fields
		$cmb->add_field( array(
			'name'  => __( '视频简介', 'cmb2' ),
			'id'    => 'post_content',
			'type'    => 'textarea', 
			'attributes' => array(
				'id'=>'submitted_post_content',
				'rows' => 5, 
			),		
		) );
		
		$cmb->add_field( array( 
			'name'    =>  __( '为视频选择一个最恰当的类别', 'cmb2' ),
			'id'      => 'submitted_post_cat',
			'type'    => 'topic_mode', 
		) );			
	
	$cmb->add_field( array( //标签
		'name'    =>  __( '添加标签' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
		'autocomplete' => 'off',
		),			
	) ); 	
 	
	$cmb->add_field( array( //站外链接
		'name' => __( '选择或注明版权信息', 'cmb2' ),
		'id'   => 'copyright',
		'type' => 'copyright',//定义在文档开头
	) );

	$cmb->add_field( array( 
		'id'      => 'zhuanzai',
		'type'    => 'text',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>"输入来源名称……",
			'showon'=>"w",
		),		
	) );
	$cmb->add_field( array( 
		'id'      => 'wangzhi',
		'type'    => 'text_link',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>"网址前请加上http://",
			'showon'=>"w",			
		),	
	) );
	
	$cmb->add_field( array( 
		'id'      => 'qikan',
		'type'    => 'text_medium',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>"输入期刊名称、期数等……",
			'showon'=>"k",//js控制
			
		),	
	) );	
	
	$cmb->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'video_script', 
	) );	
			
}

add_action( 'cmb2_init', 'post_frontend_form_register' );

/**
 * Gets the front-end-post-form cmb instance
 * @return CMB2 object
 */
function post_frontend_cmb2_get() {

	$metabox_id = 'front-end-post-form';
	
	$object_id  = 'fake-object-id';		

	return cmb2_get_metabox( $metabox_id, $object_id );
}


/**
 * Handle the cmb-frontend-form shortcode
 * @param  array  $atts Array of shortcode attributes
 * @return string       Form html
 */
function post_frontend_form_submission_shortcode( $atts = array() ) {
	
 	if ( ! current_user_can( 'edit_posts' ) ) {
		return __( '对不起！您没有权限浏览该页面 >_< ', '' );
	} 
	
	$cmb = post_frontend_cmb2_get();

	$post_types = $cmb->prop( 'object_types' );
	
	$user_id = get_current_user_id();

	$atts = shortcode_atts( array(
		'post_author' => $user_id ? $user_id : 1, // Current user, or admin
		'post_status' => 'pending',
		'post_type'   => reset( $post_types ), // Only use first object_type in array
	), $atts, 'cmb-post-frontend-form' );

	/*
	 * Let's add these attributes as hidden fields to our cmb form
	 * so that they will be passed through to our form submission
	 */
	foreach ( $atts as $key => $value ) {
		$cmb->add_hidden_field( array(
			'field_args'  => array(
				'id'    => "atts[$key]",
				'type'  => 'hidden',
				'default' => $value,
			),
		) );
	}

	// Initiate our output variable
	$output = '';

	// Get any submission errors
	if ( ( $error = $cmb->prop( 'submission_error' ) ) && is_wp_error( $error ) ) {
		// If there was an error with the submission, add it to our ouput.
		$output .= '<span class="app-tips app-tips-error">' . sprintf( __( '提交出错: %s', '' ), '<strong>'. $error->get_error_message() .'</strong>' ) . '</span>';
	}
	

	$output .= cmb2_get_metabox_form( $cmb,'fake-object-id', array( 'save_button' => __( '提交审核', 'chumi' ) ) );

	return $output;

}
add_shortcode( 'cmb-post-frontend-form', 'post_frontend_form_submission_shortcode' );

/**
 * Handles form submission on save. Redirects if save is successful, otherwise sets an error message as a cmb property
 * @return void
 */
function chumi_handle_frontend_new_post_form_submission() {

	// If no form submission, bail
	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}

	// Get CMB2 metabox object
	$cmb = post_frontend_cmb2_get();

	$post_data = array();

	// Get our shortcode attributes and set them as our initial post_data args
	if ( isset( $_POST['atts'] ) ) {
		foreach ( (array) $_POST['atts'] as $key => $value ) {
			$post_data[ $key ] = sanitize_text_field( $value );
		}
		//unset( $_POST['atts'] );
	}

	// Check security nonce
	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}
	
	// Check title submitted
	if ( empty( $_POST['submitted_post_title'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请在标题框中输入标题！' ) ) );
	}
	
	// Check content submitted
	if ( empty( $_POST['submitted_post_content'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请填写文章内容后再提交' ) ) );
	}		
	
	// Check category submitted
/* 	if ( empty( $_POST['submitted_post_cat'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请为文章选择一个分类！' ) ) );
	}	 */	

	// And that the title is not the default title
	if ( $cmb->get_field( 'submitted_post_title' )->default() == $_POST['submitted_post_title'] ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '重复！请输入一个新标题。' ) ) );
	}		

	/**
	 * Fetch sanitized values
	 */
	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	// Set our post data arguments
	$post_data['post_title']   = $sanitized_values['submitted_post_title'];
	unset( $sanitized_values['submitted_post_title'] );
	$post_data['post_content'] = $sanitized_values['submitted_post_content'];
	unset( $sanitized_values['submitted_post_content'] );
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	unset( $sanitized_values['submitted_post_tag'] );
	$post_data['post_parent'] = $sanitized_values['topic'];	
	unset( $sanitized_values['topic'] );
	$post_data['_thumbnail_id'] = $sanitized_values['post_thumbnail_id'];	
	
	$cat = $sanitized_values['submitted_post_cat'];
	
	if(empty($cat)) { $cat = 1;	}
	
	$category = get_term_by( 'id',$cat,'category')->name;
	unset( $sanitized_values['submitted_post_cat'] );	

	// Create the new post
	$new_submission_id = wp_insert_post( $post_data, true );	
	wp_set_object_terms( $new_submission_id, $category, 'category');
	$title = mb_strimwidth(strip_tags(Pinyin::getPinyin($post_data['post_title'])), 0, 60,"");
	$name = substr(md5($title), 0, 15);
	wp_update_post( array( 'ID' => $new_submission_id,'post_name'  => $name.'_'.$new_submission_id) );
		update_post_meta( $new_submission_id, 'videws', '1' );

	// If we hit a snag, update the user
	if ( is_wp_error( $new_submission_id ) ) {
		return $cmb->prop( 'submission_error', $new_submission_id );
	}
		
	/**
	 * Other than post_type and post_status, we want
	 * our uploaded attachment post to have the same post-data
	 */
	unset( $post_data['post_type'] );
	unset( $post_data['post_status'] );

	// Loop through remaining (sanitized) data, and save to post-meta
	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $new_submission_id, $key, $value );
			}
		} else {
			update_post_meta( $new_submission_id, $key, $value );
		}
	}
	
	$votecounts = rand(1,2);//随机点赞数
	update_post_meta($new_submission_id,'vote_up-count',$votecounts);
	
	/*
	 * Redirect back to the form page with a query variable with the new post ID.
	 * This will help double-submissions with browser refreshes
	 */	
	
	wp_redirect(home_url(). '/?p='.$new_submission_id);	
	
	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_new_post_form_submission' );

/*
* 文章附件绑定到文章(下列两个action同时配合)
* 假借 id_for_frontend 这个自定义字段实现
* @since BlueRed 1.0
*/
function attach_id_post_for_frontend( $attachment_id ){ // run after an attachment is added to the DB
    global $post;
    $user_id = get_current_user_id();
    $submit_id = get_page_by_path( 'fb' )->ID;
    $attachment = get_post( $attachment_id );
    if ( $attachment->post_parent == $submit_id && $user_id ){
        $tempo_ids = get_post_meta( $submit_id, 'id_for_frontend', true); // set attachment ID in the customfield of "submitpage"
        if( !$tempo_ids ) $tempo_ids = array();
        $tempo_ids = $tempo_ids += array( $attachment_id => $user_id );
        update_post_meta( $submit_id, 'id_for_frontend', $tempo_ids );
    }
    return $attachment_id;
}
add_filter( 'add_attachment', 'attach_id_post_for_frontend', 99, 2 );

function attach_save_post_for_frontend( $post_id ) {
    if ( !is_admin() ){
        $user_id = wp_get_current_user()->ID;
        $submit_id = get_page_by_path( 'fb' )->ID;
        if( get_post_type( $post_id ) === 'post' && $user_id ){ // set "post", "page", or your custom posttype
            $tempo_ids = get_post_meta( $submit_id, 'id_for_frontend', true);
            if( $tempo_ids ) : foreach ($tempo_ids as $key => $val ) : // pick attachment IDs from the customfield
                if ( $val == $user_id ){
                    $at_post = array();
                    $at_post['ID'] = $key;
                    $at_post['post_parent'] = $post_id; // set post_parent
                    wp_update_post( $at_post );
                }
                unset( $tempo_ids[$key] );
            endforeach; endif;
            if( $tempo_ids ) update_post_meta( $submit_id, 'id_for_frontend', $tempo_ids );
            else delete_post_meta( $submit_id, 'id_for_frontend' );
        }
    }
}
add_action( 'save_post', 'attach_save_post_for_frontend' ); 