<?php
 /*
Template Name: 新闻
*/ 

if ( !function_exists( 'get_default_post_to_edit' ) ) { 
    require_once ABSPATH . '/wp-admin/includes/post.php'; 
} 
  
// Optional. A post type string. Default 'post'. 
$post_type = 'post'; 
  
// Optional. Whether to insert the post into database. Default false. 
$create_in_db = false; 
  
// NOTICE! Understand what this does before running. 
$post = get_default_post_to_edit($post_type, $create_in_db); 

if( isset($_POST['message_form']) && $_POST['message_form'] == 'send') {
    global $wpdb;
    $current_url = get_site_url()/contact; 

    $last_post = $wpdb->get_var("SELECT `post_date` FROM `$wpdb->posts` ORDER BY `post_date` DESC LIMIT 1");

    if ( (current_time('timestamp') - strtotime($last_post)) < 10 ) {
        wp_die('发表博文过于频繁，请间隔10秒后重试！<a href="'.$current_url.'">点此返回</a>');
    }

    $title =  isset( $_POST['message_title'] ) ? trim(htmlspecialchars($_POST['message_title'], ENT_QUOTES)) : '';
    $content =  isset( $_POST['message_content'] ) ? trim(htmlspecialchars($_POST['message_content'], ENT_QUOTES)) : '';
    $uc_tags = isset( $_POST['message_tag'] ) ? trim(htmlspecialchars($_POST['message_tag'], ENT_QUOTES)) : '';
    
    $tags = tagchange($uc_tags); 

    // 表单项数据验证    
    if ( empty($title) || mb_strlen($title) > 100 ) {
        wp_die('标题必须填写，且长度不得超过100字。<a href="'.$current_url.'">点此返回</a>');
    }
    
    $args = array(
        'post_title' => $title, 
	'tags_input' => $tags,
	'post_content' => $content,
        'post_category' => array(1),
	'post_status' =>'publish',
	'comment_status' =>'closed',
    );


    // 将文章插入数据库
    $status = wp_insert_post( $args );
}
get_header();?>
	<div class="page_bar"></div>
	<div class="hr clearfix"></div>
<div id="wrapper" class="container_12 clearfix white-wp">
	<!-- Caption Line -->
	<br /><br />
	<h2 class="grid_6 caption clearfix">控制中心</h2>
	<div class="grid_6 pg_guider">
		<a href="/new-message">发新闻</a>
		<a href="/new-video">发视频</a>
		<a href="/new-post">写博客</a>
		<a href="/web-pannel">HOME</a>
	</div>
	<div class="hr grid_12 clearfix">&nbsp;</div>
	<!-- Column 1 / Content -->
	<div class="grid_8">
			<h4><?php the_title();?></h4>
			<div class="hr dotted clearfix">&nbsp;</div>
			<form class="bno-message" method="post" action="<?php echo $_SERVER["REQUEST_URI"]; $current_user = wp_get_current_user(); ?>" id="contact_form">
			<ul>
				<li class="clearfix">
					<label for="message_title">标题</label>
					<input type='text' value="" name="message_title" id="message_title" />
				</li>
				<li class="clearfix">
					<label for="message_content">正文</label>
					<?php  wp_editor( '', message_content, $settings = array(
					                    quicktags=>0,
					                    tinymce=>0,
      						            media_buttons=>1,
          						    textarea_rows=>4,   
					                    editor_class=>"textareastyle"
					) ); ?>
					<div class="clear"></div>
				</li>
				<li class="clearfix">
					<label for="message_tag">标签</label>
					<input type='text' value="" name='message_tag' id='message_authortel' />
					<p class="label-tips">多个标签请使用 空格 进行间隔！</p>
					<div class="clear"></div>
				</li>
				<li class="clearfix">
					<div id="button">
					        <input type="hidden" value="send" name="message_form" />
						<input type='submit' value='发送' />
					</div>
				</li>
			</ul>
		</form>
	</div>

<form id="thumbnail_upload" method="post" action="#" enctype="multipart/form-data" >
  <input type="file" name="thumbnail" id="thumbnail">
  <input type='hidden' value='<?php wp_create_nonce( 'upload_thumb' ); ?>' name='_nonce' />
  <input type="hidden" name="post_id" id="post_id" value="POSTID">
  <input type="hidden" name="action" id="action" value="my_upload_action">
  <input id="submit-ajax" name="submit-ajax" type="submit" value="upload">
<form>
<div id="output1"></div>
<script>
$(document).ready(function() { 
    var options = { 
        target:        '#output1',      // target element(s) to be updated with server response 
        beforeSubmit:  showRequest,     // pre-submit callback 
        success:       showResponse,    // post-submit callback 
        url:    ajaxurl                 // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php     
    }; 

    // bind form using 'ajaxForm' 
    $('#thumbnail_upload').ajaxForm(options); 
});
function showRequest(formData, jqForm, options) {
//do extra stuff before submit like disable the submit button
$('#output1').html('Sending...');
$('#submit-ajax').attr("disabled", "disabled");
}
function showResponse(responseText, statusText, xhr, $form)  {
//do extra stuff after submit
}
</script>


	<div class="hr grid_12 clearfix">&nbsp;</div>
<?php get_footer();?>